/*
 * The Spar Library - modular math parser
 * Copyright (C) 2000,2001 Davide Angelocola <davide178@inwind.it>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *
 */

#include <spar/sl_conf.h>
#include <spar/sl_io.h>
#include <spar/sl_init.h>
#include <stdlib.h>

void
__sl_assert_fail (const char *filename, const char *function, int line,
		  const char *expr)
{
  if (filename != NULL && filename[0] != '\0')
    sl_write ("file %s: ", filename);

  if (line != -1)
    sl_write ("line: %d: ", line);

  if (function != NULL && function[0] != '\0')
    sl_write ("function: %s(): ", function);

  sl_writeln ("SL assertion failed: '%s'", expr);

  if (sl_de_init () != SL_SUCCESS)
    sl_writeln ("sl_de_init() fails.");

  abort ();
}
