/*
 * The Spar Library - modular math parser
 * Copyright (C) 2000,2001 Davide Angelocola <davide178@inwind.it>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *
 */

#include <spar/sl_complex.h>
#include <spar/sl_math_library.h>

sl_complex
sl_complex_exp (sl_complex z)
{
  double s = sl_sin (SL_COMPLEX_IM (z));
  double c = sl_cos (SL_COMPLEX_IM (z));
  double u = sl_exp (SL_COMPLEX_RE (z));

  SL_COMPLEX_RE (z) = u * c;
  SL_COMPLEX_IM (z) = u * s;

  return z;
}
