/*
 * The Spar Library - modular math parser
 * Copyright (C) 2000,2001 Davide Angelocola <davide178@inwind.it>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *
 */
#include <spar/sl_math_library.h>
#include <spar/sl_math.h>
#include <spar/sl_error.h>


SL_MATH_FUNCTION (sl_fib)
{
  if (SL_IS_NEGATIVE (x))
    sl_error_throw (SL_ERROR_CLASS_PARSER, SL_ERROR_NEGARG, "%g", x);

  if ((x == 1.) || (x == 2.))
    return 1.;
  else
    {
      register double a = 1.;
      register double b = 1.;
      register double c = 0.;
      register int i;

      for (i = 0; i < (int) x; i++)
	{
	  c = a + b;
	  a = b;
	  b = c;
	}

      return c;
    }
}
