/*
 * The Spar Library - modular math parser
 * Copyright (C) 2000,2001 Davide Angelocola <davide178@inwind.it>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *
 */
#include <string.h>

#include <spar/sl_parser.h>

void
sl_variable_edit_comment (sl_variable * entry, const char *comment)
{
  strncpy (entry->comment, comment, SL_MESSAGE_LENGHT);

  return;
}

void
sl_variable_edit_name (sl_variable * entry, const char *name)
{
  strncpy (entry->name, name, SL_IDENTIFIER_LENGHT);

  return;
}

void
sl_variable_edit_value (sl_variable * entry, double value)
{
  entry->value = value;

  return;
}

void
sl_variable_old_value (sl_variable * entry)
{
  double tmp = entry->value;

  entry->value = entry->old_value;
  entry->old_value = tmp;

  return;
}
